// Iconos en rea de notificacin
// Fichero fuente
// Mayo de 2013 Con Clase
// Salvador Pozo

#include <windows.h>

#define MENSAJE WM_USER+11

/*  Declare Windows procedure  */
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void MostrarIcono(HWND);
void CambiarIcono(HWND hwnd, HICON hIcon);
void CambiarTexto(HWND hwnd, const char *cad);
void OcultarIcono(HWND);

/*  Make the class name into a global variable  */
char szClassName[ ] = "AplicacionConClase";

int WINAPI WinMain (HINSTANCE hThisInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR lpszArgument,
                     int nCmdShow)
{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default colour as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "Icono de notificacin",       /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nCmdShow);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WindowProcedure */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


/*  This function is called by the Windows function DispatchMessage()  */

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static int n;
    HINSTANCE hInstance;
    HICON hIcon;

    switch (message) { /* handle the messages */
        case WM_CREATE:
            hInstance = GetModuleHandle(0);
            CreateWindowEx(0, "BUTTON", "Ocultar", BS_PUSHBUTTON | WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP,
                9, 19, 95, 24, hwnd, (HMENU)IDOK, hInstance, NULL);
            SetTimer(hwnd, 1, 250, 0);
            n=0;
            break;
        case WM_TIMER:
            KillTimer(hwnd, 1);
            switch(n) {
                case 0:
                    hIcon = LoadIcon(GetModuleHandle(0), "Icono1");
                    n = 1;
                    break;
                case 1:
                    hIcon = LoadIcon(GetModuleHandle(0), "Icono2");
                    n = 2;
                    break;
                case 2:
                    hIcon = LoadIcon(GetModuleHandle(0), "Icono3");
                    n = 3;
                    break;
                case 3:
                    hIcon = LoadIcon(GetModuleHandle(0), "Icono4");
                    n = 0;
                    break;
            }
            CambiarIcono(hwnd, hIcon);
            SetTimer(hwnd, 1, 250, 0);
            break;
        case MENSAJE:
            switch(lParam) {
                case WM_LBUTTONUP:
                    OcultarIcono(hwnd);
                    ShowWindow (hwnd, SW_RESTORE);
                    break;
            }
            break;
        case WM_COMMAND:
            ShowWindow(hwnd, SW_HIDE);
            MostrarIcono(hwnd);
            CambiarTexto(hwnd, "Pulsame para restaurar la venana.");
            break;
        case WM_DESTROY:
            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}

void MostrarIcono(HWND hwnd) {
    HICON hIcon = LoadIcon(GetModuleHandle(0), "Icono1");
    NOTIFYICONDATA nid;

    nid.cbSize = sizeof(nid);
    nid.hWnd = hwnd;
    nid.uID = 3200;
    nid.uFlags = NIF_ICON | NIF_MESSAGE;
    nid.uCallbackMessage = MENSAJE;
    nid.hIcon = hIcon;
    Shell_NotifyIcon(NIM_ADD, &nid);
    DestroyIcon(hIcon);
}

void CambiarIcono(HWND hwnd, HICON hIcon) {
    NOTIFYICONDATA nid;

    nid.cbSize = sizeof(nid);
    nid.hWnd = hwnd;
    nid.uID = 3200;
    nid.uFlags = NIF_ICON;
    nid.hIcon = hIcon;
    Shell_NotifyIcon(NIM_MODIFY, &nid);
    DestroyIcon(hIcon);
}

void CambiarTexto(HWND hwnd, const char *cad) {
    NOTIFYICONDATA nid;

    nid.cbSize = sizeof(nid);
    nid.hWnd = hwnd;
    nid.uID = 3200;
    nid.uFlags = NIF_TIP;
    strcpy(nid.szTip, cad);
    Shell_NotifyIcon(NIM_MODIFY, &nid);
}

void OcultarIcono(HWND hwnd) {
    NOTIFYICONDATA nid;

    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd = hwnd;
    nid.uID = 3200;

    Shell_NotifyIcon(NIM_DELETE, &nid);
}
